PathFind = {

}

function PathFind:solveNodes(startNode, targetNode)
    --local currentNode = startNode
    local numNodesFound = 0
    local nodesFound = {}
    local changedNodes = {}
    changedNodes[startNode.id] = startNode
    startNode.estimate = 0
    activeNodes = {}
    table.insert(activeNodes, startNode)
    repeat
        local newActive = {}
        for k, currentNode in ipairs(activeNodes) do
            local canGoDown = true
            local nodesToAdd = {}
            for node, dis in pairs(currentNode.nodeConnections) do
                if (node.estimate == nil or node.estimate > currentNode.estimate + dis) then
                    node.estimate = currentNode.estimate + dis
                    node.previousNode = currentNode
                    if node == targetNode then
                        canGoDown = false
                    end
                    table.insert(nodesToAdd, node)
                end
                if node == targetNode and nodesFound[currentNode] == nil then
                    numNodesFound = numNodesFound + 1
                    nodesFound[currentNode] = true
                    
                end
                changedNodes[node.id] = node
            end  
            if canGoDown then
                for k, node in ipairs(nodesToAdd) do
                    table.insert(newActive, node)
                end
            end
        end
        activeNodes = newActive
        
    until #newActive == 0 or numNodesFound == targetNode.numNodes
    
    if numNodesFound == 0 then
        for id, node in pairs(changedNodes) do
            node:reset()
        end
        return nil
    end
    
    local nodes = {}
    local currentNode = targetNode
    table.insert(nodes, targetNode)
    repeat
        currentNode = currentNode.previousNode
        table.insert(nodes, 1,currentNode)
    until currentNode == startNode
    
    for id, node in pairs(changedNodes) do
        node:reset()
    end
    return nodes
end


PathFind.Node = class("PathFind Node")

PathFind.Node.id = 0
function PathFind.Node:init(name)
    self.id = PathFind.Node.id + 1
    PathFind.Node.id = PathFind.Node.id + 1
    self.name = name
    self.nodeConnections = {}
    self:reset()
    self.numNodes = 0
end

function PathFind.Node:reset()
    self.explored = false
    self.estimate = nil
    self.previousNode = nil
    self.noForward = false
end

function PathFind:makeConnection(node1, node2, dis)
    node1.nodeConnections[node2] = dis
    node2.nodeConnections[node1] = dis
    node1.numNodes = node1.numNodes + 1
    node2.numNodes = node2.numNodes + 1
end

function PathFind.Node:delete()
    for node, k in pairs(self.nodeConnections) do
        node.numNodes = node.numNodes - 1
        self.nodeConnections[node] = nil
        node.nodeConnections[self] = nil
    end
    self.numNodes = 0
end

function PathFind:makeConnections(nodes)
    for k, v in ipairs(nodes) do
        PathFind:makeConnection(table.unpack(v))
    end
end

table.contains = function(tab, val) 
    for index, value in ipairs(tab) do
        if value == val then
            return true
        end
    end
    return false
end